#=============================================================================
# Copyright (C) 2003           Ikki Ohmukai,      All rights reserved.
#
#
# This file is part of RNA.
#
#    RNA is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    RNA is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with RNA; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#=============================================================================
# Trackback 関連のモジュール
#=============================================================================
package RNA::Trackback;

use strict;
use Jcode;
use RNA::AntennaTree;
use RNA::RSS;
use RNA::Utils;

# $tree = get_trackback_tree($item->{link});
#
#    RNA::Antenna オブジェクトを返す
sub get_trackback_tree
{
	my $uri = shift;

	# html 文書を取得
	my $str = &main::get_html($uri);
	Jcode::convert(\$str, 'utf8');	# UTF-8 に変換

	my $antenna = '';

	# trackback 情報の取得
	my $tb_ping_uri = '';
	if($str =~ /\<rdf:Description.*?trackback:ping=\"(.+?)\".*?\/?\s*\>/si){
		$tb_ping_uri = $1;

		# trackback CGI から情報取得
		$str = &main::get_html($tb_ping_uri . '?__mode=rss');
		Jcode::convert(\$str, 'utf8');	# UTF-8 に変換
# print STDERR $str;

		my $rss = new RNA::RSS;
		$rss->parse($str);

		$antenna = new RNA::AntennaTree;
		$antenna->set_from_items_array(\@{$rss->{items}});
#print STDERR $antenna->{items}->[0]->{channel}->{title} . " : "
#	. $antenna->{items}->[0]->{channel}->{link} . "\n"
	}

	return $antenna;
}



1;
__END__

